Subject: RE: bug#22991: 25.0.92: C-u C-s does not display "Regexp I-search:" in the echo area

From: Drew Adams <[email-masked]>
Date: Sat, 12 Mar 2016 07:14:28 -0800 (PST)

> > Sorry, I just remembered that I was one of the people (or the only one?)
> > who suggested not displaying "Char-fold" prefix.
> >
> > But considering the example that Michael gave, it makes sense to remove
> > that condition from the cond form. I would actually like to see
> > "Regexp I-search:" even if I have set that by default.
> >
> > The result will be a less complex cond statement (will get rid of that
> > "oring of ands" case in my last patch) and clarity as to what's the
> > current isearch mode.
> >
> > What do you guys think? Or should we bring this up on emacs-devel?
> 
> First, such a change would be a change in behavior, so it should go to
> master, not emacs-25.
> 
> Second, I don't agree with Michael, so if we want to allow such a
> different behavior, I will insist on a user option.

1. I agree with Michael in this case.  The prompt should
faithfully reflect the current search state/mode - until we
find a better way to convey that information.  In any case,
the prompt should not mislead by reflecting a different
search behavior from what is current.

2. Whether this or that behavior is turned on by default
should not override that rule that the prompt tells you what
the state is.

3. To be more clear, perhaps the non-regexp, non-fold search
(including not folding whitespace) should also have a prompt
that unambiguously indicates this.  It is essentially
"literal" search.

4. All of that said, I think that we really need to find
some _other way than the prompt_ to indicate, completely,
the search state.  And then the prompt can perhaps just be
something like "Isearch" in all cases.  The prompt is not
adequate for conveying just what the current search state is.

5. This should be discussed on emacs-devel (again).

6. While waiting for a redesign in this regard and a
general decision, the prompt should reflect the default
state.  If it is super important that beginning users not
be frightened by a weird prompt by default, at the outset,
then we should turn off char-fold search by default - for now.